<?php
/*
 * This file is part of the Easy-CMS project.
 * Easy-CMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Easy-CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Easy-CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
	
include_once('classes/utils/Iterator.class.php');

class SortedListIterator extends _Iterator
{	
	var $sortedList;

	function SortedListIterator(&$sortedListObj){
		$this->sortedList = &$sortedListObj;
		$this->reset();
	}

	// Sets internal pointer to the first element
	function reset(){
		$root    = &$this->sortedList->getRoot();
		$this->p = &$root;
	}

	// Sets internal pointer to the last element
	function end() {
		$this->reset();
	}

	// Sets internal pointer to desired position
	function seek($position) {
		
	}

	function hasNext(){
		$next = &$this->p->getNext();
		if ($next == null)
			return false;
		return ($next->getValue() != null);
	}

	function hasPrevious(){
		$prev = &$this->p->getPrev();
		return ($prev->getValue() != NULL);		
	}
	
	// Returns next element in the iteration
	function &next(){
		$next = &$this->p->getNext();
		$this->p = &$next;
		return $this->p->getValue();	
	}
	
	// Returns previous element in the iteration	
	function &previous(){
		$prev = &$this->p->getPrev();
		$this->p = &$prev;
		return $this->p->getValue();		
	}
}
?>